# Written by Owen Williams
# see LICENSE for license information
import penguintv


class PreferencesDialog:
	def __init__(self,xml,app):
		self.xml = xml
		self._app = app
		self._window = xml.get_widget("window_preferences")
		for key in dir(self.__class__):
			if key[:3] == 'on_':
				self.xml.signal_connect(key, getattr(self,key))
		self.feed_refresh_widget = self.xml.get_widget("feed_refresh")
		self.feed_refresh_widget.set_text(str(self._app.polling_frequency/(60*1000)))
		self.player_cmdline_widget = self.xml.get_widget("player_cmdline")
		self.player_cmdline_model = self.player_cmdline_widget.get_model()
		self.set_player_cmdline(self._app.get_player_cmdline())
		
		self.min_port_widget = self.xml.get_widget("min_port_entry")
		self.max_port_widget = self.xml.get_widget("max_port_entry")
		self.ul_limit_widget = self.xml.get_widget("upload_limit_entry")
		
		self.autoresume = self.xml.get_widget("auto_resume")
	#	self.dl_limit_widget = self.xml.get_widget("download_limit_entry")

		
			
#		self.player_cmdline_widget.set_active(self._app.get_player_cmdline())
				
	def show(self):
		self._window.show()
		
	def hide(self):
		#self.feed_refresh_widget.set_text("")
		self._window.hide()
		
	def set_player_cmdline(self, player_cmdline):
		i=0
		found=0
		child = self.player_cmdline_model.get_iter_root()
		while child is not None:
			if self.player_cmdline_model.get_value(child,0) == player_cmdline:
				found=1
				break
			child = self.player_cmdline_model.iter_next(child)
			i=i+1
		if found ==1:
			self.player_cmdline_widget.set_active(i)		
		else:
			self.player_cmdline_model.append((player_cmdline,))
			self.player_cmdline_widget.set_active(len(self.player_cmdline_model)-1)		

	def set_feed_refresh_frequency(self, freq):
		self.feed_refresh_widget.set_text(str(freq/(60*1000)))
		
	def set_bt_settings(self, bt_settings):
		self.min_port_widget.set_text(str(bt_settings['min_port']))
		self.max_port_widget.set_text(str(bt_settings['max_port']))		
		self.ul_limit_widget.set_text(str(bt_settings['ul_limit']))			
	#	self.dl_limit_widget.set_text(str(bt_settings['dl_limit']))			
	
	def set_auto_resume(self, autoresume):
		self.autoresume.set_active(autoresume)
				

	def on_button_apply_clicked(self,event):
		#self._app.add_feed(self.feed_url_widget.get_text())
	#	try:
		self._app.set_polling_frequency(int(self.feed_refresh_widget.get_text()))
		self._app.set_player_cmdline(self.player_cmdline_widget.get_active_text())
		new_bt_settings = {'min_port':int(self.min_port_widget.get_text()),
											 'max_port':int(self.max_port_widget.get_text()),
											 'ul_limit':int(self.ul_limit_widget.get_text())}
					#						 'dl_limit':int(self.dl_limit_widget.get_text())}
		self._app.set_bt_settings(new_bt_settings)
		self._app.set_auto_resume(self.autoresume.get_active())
	#	except:
	#		pass	
	#	self.hide()
	
	def on_button_close_clicked(self,event):
		self.hide()
