# Written by Owen Williams
# see LICENSE for license information
import os,sys,time
import fnmatch

VERSION="0.76"

def format_size(size):
	if size > 1000000000:
		return str(size/1000000000)+" GB"
	elif size > 1000000:
		return str(size/1000000)+ " MB"
	elif size > 1000:
		return str(size/1000)+" KB"
	else:
		return str(size)+" bytes"
		
def GetPrefix():
	h, t = os.path.split(os.path.split(os.path.abspath(sys.argv[0]))[0])
	return h

def hours(n):  #this func copyright Bram Cohen
    if n == -1:
        return '<unknown>'
    if n == 0:
        return 'complete!'
    n = long(n)
    h, r = divmod(n, 60 * 60)
    m, sec = divmod(r, 60)
    if h > 1000000:
        return '<unknown>'
    if h > 0:
        return '%d:%02d:%02d' % (h, m, sec)
    else:
        return '%d:%02d' % (m, sec)

def is_known_media(filename):
	good_ext = [
				'mp3','ogg','flac', 'wav', #windows audio
				'mp4','m4p','aac','aif',   #mac audio
				'avi','wmv','asf',         #windows video
				'mov',                     #mac
				'ogm','mkv']               #weird but ok I think
	
	ext = filename[filename.rfind(".")+1:].lower()
	
	if ext in good_ext:
		return True
	else:
		return False
				
def get_dated_dir():
	today = time.strftime("%Y-%m-%d")
	return today				
			
#http://www.faqts.com/knowledge_base/view.phtml/aid/2682
class GlobDirectoryWalker:
    # a forward iterator that traverses a directory tree

    def __init__(self, directory, pattern="*"):
        self.stack = [directory]
        self.pattern = pattern
        self.files = []
        self.index = 0

    def __getitem__(self, index):
        while 1:
            try:
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # pop next directory from stack
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # got a filename
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                if fnmatch.fnmatch(file, self.pattern):
                    return fullname
#usage:
#for file in GlobDirectoryWalker(".", "*.py"):
#    print file
